From bf0cc18fd9ecfd1d9e0a97ccd1db796435385a3a Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Thu, 28 Jan 2010 00:56:16 +0100
Subject: [PATCH 11/11] Use VLC_FEATURE_OPTION and require default values.

Bye bye negative logic.
Also provide a possibility to disable sqlite.

Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac       |  717 +++++++++++++++++++++++-----------------------------
 m4/vlc_features.m4 |   45 +---
 m4/with_pkg.m4     |    3 +-
 3 files changed, 325 insertions(+), 440 deletions(-)

diff --git a/configure.ac b/configure.ac
index 5011221..e7ee60b 100644
--- a/configure.ac
+++ b/configure.ac
@@ -199,9 +199,9 @@ case "${host_os}" in
     VLC_ADD_LDFLAGS([avcodec avformat access_avio swscale postproc i420_rgb_mmx x264],[-Wl,-read_only_relocs,suppress])
     VLC_ADD_CFLAGS([motion],[-fconstant-cfstrings])
     VLC_ADD_LDFLAGS([libvlccore],[-Wl,-framework,CoreFoundation])
-    AC_ARG_ENABLE(macosx-defaults,
-      AS_HELP_STRING([--enable-macosx-defaults],[Build the default configuration on Mac OS X (default enabled)]))
-    AS_IF([VLC_FEATURE_NOT_DISABLED([macosx-defaults])], [
+    VLC_FEATURE_DEFAULT_ENABLE([macosx-defaults])
+    VLC_FEATURE_OPTION([macosx-defaults], [Build the default configuration on Mac OS X], [enabled on Mac OS X])
+    AS_IF([VLC_FEATURE_ENABLED([macosx-defaults])], [
         echo ""
         echo "Building with Mac OS X defaults:"
         with_macosx_version_min="10.5"
@@ -310,11 +310,13 @@ case "${host_os}" in
         dnl
         dnl DEP and ASLR options
         dnl
-        AC_ARG_ENABLE(peflags,
-          [  --enable-peflags        peflags use (default enabled on Windows)])
-        AS_IF([VLC_FEATURE_NOT_DISABLED([peflags])], [
+        VLC_FEATURE_DEFAULT_ENABLE([peflags])
+        VLC_FEATURE_OPTION([peflags], [peflags use], [enabled on Windows])
+        AS_IF([VLC_FEATURE_ENABLED([peflags])], [
           AC_CHECK_TOOL(PEFLAGS, peflags, :)
         ])
+    else
+      VLC_FEATURE_DEFAULT_DISABLE([peflags])
     fi
     if test "${SYS}" = "mingwce"; then
         # add ws2 for closesocket, select, recv
@@ -498,7 +500,7 @@ AC_PREPROC_IFELSE([
   AC_MSG_RESULT([not present])
 ], [
   AC_MSG_RESULT([found])
-  AS_IF([VLC_FEATURE_NOT_DISABLED([nls]) || VLC_FEATURE_NOT_DISABLED([mozilla])], [
+  AS_IF([VLC_FEATURE_ENABLED([nls]) || VLC_FEATURE_ENABLED([mozilla])], [
     AC_MSG_ERROR([Buggy GNU/libc (version 2.5 - 2.7) present. VLC would crash; there is no viable
 work-around for this. Check with your distribution vendor on how to update the
 glibc run-time. Alternatively, build with --disable-nls --disable-mozilla and
@@ -895,27 +897,34 @@ AM_CONDITIONAL(HAVE_MINIZIP, [ test "${have_minizip}" = "yes" ])
 
 
 dnl Check for dbus
-AC_ARG_ENABLE(dbus,
-  [  --enable-dbus           Linux D-BUS message bus system (default enabled)])
-case "${SYS}" in
-    linux*|*bsd*)
-AS_IF([VLC_FEATURE_NOT_DISABLED([dbus]) && test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce"], [
+AS_CASE(
+  ["${SYS}"],
+  [linux*|*bsd*], [
+    AS_IF([test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce"], [
+      VLC_FEATURE_DEFAULT_ENABLE([dbus dbus-control telepathy])
+    ])
+  ], [
+    VLC_FEATURE_DEFAULT_DISABLE([dbus dbus-control telepathy])
+  ]
+)
+
+VLC_FEATURE_OPTION([dbus], [Linux D-BUS message bus system], [auto])
+VLC_FEATURE_OPTION([dbus-control], [D-BUS control interface], [auto])
+VLC_FEATURE_OPTION([telepathy], [Telepathy Presence plugin through DBus], [auto])
+AS_IF([VLC_FEATURE_ENABLED([dbus])], [
   dnl api stable dbus
   PKG_CHECK_MODULES(DBUS, dbus-1 >= 1.0.0,
     [ AC_DEFINE( HAVE_DBUS, 1, [Define if you have the D-BUS library] )
       VLC_ADD_LIBS([libvlccore],[$DBUS_LIBS])
       VLC_ADD_CFLAGS([libvlccore],[$DBUS_CFLAGS])
       dnl Check for dbus control interface
-        AC_ARG_ENABLE(dbus-control, [  --disable-dbus-control  D-BUS control interface (default enabled)])
-        AS_IF([VLC_FEATURE_NOT_DISABLED([dbus_control])], [
+      AS_IF([VLC_FEATURE_ENABLED([dbus-control])], [
           VLC_ADD_PLUGIN([dbus])
           VLC_ADD_LIBS([dbus],[$DBUS_LIBS])
           VLC_ADD_CFLAGS([dbus],[$DBUS_CFLAGS])
         ])
       dnl Check for Telepathy
-        AC_ARG_ENABLE(telepathy,
-          AS_HELP_STRING([--enable-telepathy],[Telepathy Presence plugin through DBus(default enabled)]))
-        AS_IF([VLC_FEATURE_NOT_DISABLED([telepathy])], [
+        AS_IF([VLC_FEATURE_ENABLED([telepathy])], [
           VLC_ADD_PLUGIN([telepathy])
           VLC_ADD_LIBS([telepathy],[$DBUS_LIBS])
           VLC_ADD_CFLAGS([telepathy],[$DBUS_CFLAGS])
@@ -928,8 +937,6 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dbus]) && test "${SYS}" != "mingw32" && test "$
     [AC_MSG_ERROR([Couldn't find DBus >= 1.0.0, install libdbus-dev ?])]
   )
 ])
-;;
-esac
 
 dnl Check for ntohl, etc.
 AC_CACHE_CHECK([for ntohl in sys/param.h],
@@ -946,8 +953,7 @@ CFLAGS="${CFLAGS_save}"
 RDC_PROG_CC_WFLAGS([all extra sign-compare undef pointer-arith bad-function-cast write-strings missing-prototypes volatile-register-var error-implicit-function-declaration])
 RDC_PROG_CC_FLAGS([-pipe])
 
-AC_ARG_ENABLE(warnings-as-error,
-      AS_HELP_STRING([--enable-warnings-as-error],[Treat acceptable warnings as error (default disabled)]))
+VLC_FEATURE_OPTION([warnings-as-error], [Treat acceptable warnings as error], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([warnings-as-error])], [
     RDC_PROG_CC_WERRORFLAGS([unused-function unused-label unused-value unused-parameter unused-variable unused \
      missing-braces nonnull parentheses uninitialized address enum-compare undef comment switch \
@@ -979,14 +985,14 @@ AC_CACHE_CHECK([if \$CC accepts -O4],
     [ac_cv_c_o4],
     [CFLAGS="${CFLAGS_save} -O4"
      AC_TRY_COMPILE([],,ac_cv_c_o4=yes, ac_cv_c_o4=no)])
-if test "${ac_cv_c_o4}" != "no" && VLC_FEATURE_NOT_ENABLED([debug]); then
+if test "${ac_cv_c_o4}" != "no" && VLC_FEATURE_DISABLED([debug]); then
     CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O4"
 else
     AC_CACHE_CHECK([if \$CC accepts -O3],
         [ac_cv_c_o3],
         [CFLAGS="${CFLAGS_save} -O3"
          AC_TRY_COMPILE([],,ac_cv_c_o3=yes, ac_cv_c_o3=no)])
-    if test "${ac_cv_c_o3}" != "no" && VLC_FEATURE_NOT_ENABLED([debug]); then
+    if test "${ac_cv_c_o3}" != "no" && VLC_FEATURE_DISABLED([debug]); then
         CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O3"
     else
         AC_CACHE_CHECK([if \$CC accepts -O2],
@@ -1105,12 +1111,8 @@ AC_CHECK_FUNCS(backtrace)
 dnl
 dnl  Enable profiling
 dnl
-VLC_FEATURE_DEFAULT_DISABLE([gprof])
-VLC_FEATURE_DEFAULT_DISABLE([cprof])
-AC_ARG_ENABLE(gprof,
-[  --enable-gprof          gprof profiling (default disabled)])
-AC_ARG_ENABLE(cprof,
-[  --enable-cprof          cprof profiling (default disabled)])
+VLC_FEATURE_OPTION([gprof], [gprof profiling], [disabled])
+VLC_FEATURE_OPTION([cprof], [cprof profiling], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([cprof])], [vlc_config_cprof="yes"], [vlc_config_cprof="no"])
 AS_IF([VLC_FEATURE_ENABLED([gprof])], [vlc_config_gprof="yes"], [vlc_config_gprof="no"])
 
@@ -1154,11 +1156,10 @@ AS_CASE(
   [i?86|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([mmx])],
   [VLC_FEATURE_DEFAULT_DISABLE([mmx])]
 )
-AC_ARG_ENABLE(mmx,
-[  --disable-mmx           disable MMX optimizations (default auto)])
+VLC_FEATURE_OPTION([mmx], [enable MMX optimizations], [auto])
 have_mmx="no"
 have_mmxext="no"
-AS_IF([VLC_FEATURE_NOT_DISABLED([mmx])], [
+AS_IF([VLC_FEATURE_ENABLED([mmx])], [
   ARCH="${ARCH} mmx"
 
   AC_CACHE_CHECK([if $CC groks MMX intrinsics],
@@ -1218,10 +1219,9 @@ AS_CASE(
   [i686|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([sse])],
   [VLC_FEATURE_DEFAULT_DISABLE([sse])]
 )
-AC_ARG_ENABLE(sse,
-[  --disable-sse           disable SSE (1, 2, 3 and 4) optimizations (default auto)])
+VLC_FEATURE_OPTION([sse], [enable SSE (1, 2, 3 and 4) optimizations], [auto])
 have_sse2="no"
-AS_IF([VLC_FEATURE_NOT_DISABLED([sse])], [
+AS_IF([VLC_FEATURE_ENABLED([sse])], [
   ARCH="${ARCH} sse sse2"
 
   AC_CACHE_CHECK([if $CC groks SSE2 intrinsics],
@@ -1339,9 +1339,8 @@ AS_IF([test "x${host_cpu}" = "xarm"], [
   VLC_FEATURE_DEFAULT_DISABLE([neon])
 ])
 
-AC_ARG_ENABLE(neon,
-[  --disable-neon          disable NEON optimizations (default auto)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([neon])], [
+VLC_FEATURE_OPTION([neon], [enable NEON optimizations], [auto])
+AS_IF([VLC_FEATURE_ENABLED([neon])], [
   AC_CACHE_CHECK([if $CC groks NEON inline assembly], [ac_cv_neon_inline], [
     CFLAGS="${CFLAGS_save} -mfpu=neon"
     AC_COMPILE_IFELSE([
@@ -1365,8 +1364,7 @@ AS_IF([test "x${host_cpu}" = "xpowerpc"], [
 ], [
   VLC_FEATURE_DEFAULT_DISABLE([altivec])
 ])
-AC_ARG_ENABLE(altivec,
-[  --disable-altivec       disable AltiVec optimizations (default auto)])
+VLC_FEATURE_OPTION([altivec], [enable AltiVec optimizations], [auto])
 have_altivec="no"
 AS_IF([VLC_FEATURE_ENABLED([altivec])], [
   ARCH="${ARCH} altivec";
@@ -1508,8 +1506,7 @@ AS_IF([test "${CFLAGS_TUNING}"],
 dnl
 dnl  Memory usage
 dnl
-AC_ARG_ENABLE(optimize-memory,
-[  --enable-optimize-memory optimize memory usage over performance])
+VLC_FEATURE_OPTION([optimize-memory], [optimize memory usage over performance], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([optimize-memory])], [
   AC_DEFINE(OPTIMIZE_MEMORY, 1, Define if you want to optimize memory usage over performance)
 ])
@@ -1517,9 +1514,8 @@ AS_IF([VLC_FEATURE_ENABLED([optimize-memory])], [
 dnl
 dnl  Enable/disable optimizations
 dnl
-AC_ARG_ENABLE(optimizations,
-[  --disable-optimizations disable compiler optimizations (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([optimizations])], [
+VLC_FEATURE_OPTION([optimizations], [disable compiler optimizations])
+AS_IF([VLC_FEATURE_ENABLED([optimizations])], [
   AS_IF([VLC_FEATURE_ENABLED([optimize-memory])], [
     vlc_config_optimizations="size"
   ], [
@@ -1532,8 +1528,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([optimizations])], [
 dnl
 dnl  Debugging mode
 dnl
-AC_ARG_ENABLE(debug,
-[  --enable-debug          debug mode (default disabled)])
+VLC_FEATURE_OPTION([debug], [debug mode], [disabled])
 AH_TEMPLATE(NDEBUG,
             [Define to 1 if debug code should NOT be compiled])
 vlc_config_debug="no"
@@ -1547,8 +1542,7 @@ AS_IF([VLC_FEATURE_ENABLED([debug])], [
 dnl
 dnl Allow runing as root (usefull for people runing on embedded platforms)
 dnl
-AC_ARG_ENABLE(run-as-root,
-[  --enable-run-as-root    allow runing VLC as root (default disabled)])
+VLC_FEATURE_OPTION([run-as-root], [allow running VLC as root], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([run-as-root])], [
     AC_DEFINE(ALLOW_RUN_AS_ROOT, 1,
               [Define to 1 to allow runing VLC as root (uid 0).])
@@ -1557,8 +1551,7 @@ AS_IF([VLC_FEATURE_ENABLED([run-as-root])], [
 dnl
 dnl  Test coverage
 dnl
-AC_ARG_ENABLE(coverage,
-	[  --enable-coverage       build for test coverage (default disabled)])
+VLC_FEATURE_OPTION([coverage], [build for test coverage], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([coverage])], [
 	CFLAGS="-fprofile-arcs -ftest-coverage ${CFLAGS}"
 	CXXFLAGS="-fprofile-arcs -ftest-coverage ${CXXFLAGS}"
@@ -1572,25 +1565,21 @@ AS_IF([VLC_FEATURE_ENABLED([coverage])], [
 dnl
 dnl  Enable release-specific flags
 dnl
-AC_ARG_ENABLE(release,
-[  --enable-release        activate extra optimizations (default disabled)])
+VLC_FEATURE_OPTION([release], [activate extra optimizations], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([release])], [vlc_config_release="yes"], [vlc_config_release="no"])
 
 dnl
 dnl Stream output
 dnl
-AC_ARG_ENABLE(sout,
-  [  --enable-sout           Stream output modules (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+VLC_FEATURE_OPTION([sout], [Stream output modules])
+AS_IF([VLC_FEATURE_ENABLED([sout])], [
   AC_DEFINE(ENABLE_SOUT, 1, [Define to 1 for stream output support.])
 ])
-AM_CONDITIONAL(ENABLE_SOUT, [test "${enable_sout}" != "no"])
+AM_CONDITIONAL(ENABLE_SOUT, [VLC_FEATURE_ENABLED([sout])])
 
 dnl Lua modules
-AC_ARG_ENABLE(lua,
-  AS_HELP_STRING([--enable-lua],[lua playlist, metafetcher and interface
-		  plugins (default enabled)]))
-AS_IF([VLC_FEATURE_NOT_DISABLED([lua])], [
+VLC_FEATURE_OPTION([lua], [lua playlist, metafetcher and interface])
+AS_IF([VLC_FEATURE_ENABLED([lua])], [
   PKG_CHECK_MODULES(LUA, lua5.1,
     [ have_lua=yes ],
     [
@@ -1629,20 +1618,18 @@ AM_CONDITIONAL(BUILD_LUA, [test "${have_lua}" = "yes"])
 dnl
 dnl HTTP daemon
 dnl
-AC_ARG_ENABLE(httpd,
-  [  --enable-httpd          HTTP daemon (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([httpd])], [
+VLC_FEATURE_OPTION([httpd], [HTTP daemon])
+AS_IF([VLC_FEATURE_ENABLED([httpd])], [
   VLC_ADD_PLUGIN([oldhttp])
   AC_DEFINE(ENABLE_HTTPD, 1, Define if you want the HTTP dameon support)
 ])
-AM_CONDITIONAL(BUILD_HTTPD, [VLC_FEATURE_NOT_DISABLED([httpd])])
+AM_CONDITIONAL(BUILD_HTTPD, [VLC_FEATURE_ENABLED([httpd])])
 
 dnl
 dnl libproxy support
 dnl
-AC_ARG_ENABLE(libproxy,
-  [  --enable-libproxy       libproxy support (default auto)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([libproxy])], [
+VLC_FEATURE_OPTION([libproxy], [libproxy support])
+AS_IF([VLC_FEATURE_ENABLED([libproxy])], [
   PKG_CHECK_MODULES(LIBPROXY, libproxy-1.0, [
     AC_DEFINE(HAVE_LIBPROXY, 1, [Define if libproxy is available])
     VLC_ADD_CFLAGS([access_http],[$LIBPROXY_CFLAGS])
@@ -1658,23 +1645,25 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libproxy])], [
 dnl
 dnl VideoLAN manager
 dnl
-VLC_FEATURE_DEFAULT([vlm], ["${enable_sout}"])
-AC_ARG_ENABLE(vlm,
-  [  --enable-vlm            VideoLAN manager (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([vlm])], [
-  AS_IF([VLC_FEATURE_DISABLED([sout])], [
+AS_IF([VLC_FEATURE_REQUESTED([sout])], [
+  VLC_FEATURE_DEFAULT_ENABLE([vlm])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([vlm])
+])
+VLC_FEATURE_OPTION([vlm], [VideoLAN manager], [enabled if you have Stream output modules])
+AS_IF([VLC_FEATURE_ENABLED([vlm])], [
+  AS_IF([VLC_FEATURE_REMOVED([sout])], [
     AC_MSG_ERROR([VLM requires the stream output. Do not use --disable-sout.])
   ])
   AC_DEFINE(ENABLE_VLM, 1, [Define if you want the VideoLAN manager support])
   VLC_ADD_PLUGIN([oldtelnet])
 ])
-AM_CONDITIONAL([ENABLE_VLM], [VLC_FEATURE_NOT_DISABLED([vlm])])
+AM_CONDITIONAL([ENABLE_VLM], [VLC_FEATURE_ENABLED([vlm])])
 
 dnl
 dnl Growl notification plugin
 dnl
-AC_ARG_ENABLE(growl,
-  [  --enable-growl          growl notification plugin (default disabled)])
+VLC_FEATURE_OPTION([growl], [growl notification plugin], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([growl])], [
     VLC_ADD_PLUGIN([growl_udp])
     AC_CHECK_HEADERS(Growl/GrowlDefines.h, [
@@ -1694,18 +1683,16 @@ dnl
 dnl Audioscrobbler plugin
 dnl
 
-AC_ARG_ENABLE(audioscrobbler,
-  [  --disable-audioscrobbler Last.fm submission plugin (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([audioscrobbler])], [
+VLC_FEATURE_OPTION([audioscrobbler], [Last.fm submission plugin])
+AS_IF([VLC_FEATURE_ENABLED([audioscrobbler])], [
         VLC_ADD_PLUGIN([audioscrobbler])
   ])
 
 dnl
 dnl Taglibplugin
 dnl
-AC_ARG_ENABLE(taglib,
-  [  --disable-taglib        Taglib support (default enabled) ])
-  AS_IF([VLC_FEATURE_NOT_DISABLED([taglib])], [
+VLC_FEATURE_OPTION([taglib], [Taglib support])
+  AS_IF([VLC_FEATURE_ENABLED([taglib])], [
     PKG_CHECK_MODULES(TAGLIB, taglib >= 1.5,
       [ VLC_ADD_PLUGIN([taglib])
         VLC_ADD_LIBS([taglib],[$TAGLIB_LIBS -lz])
@@ -1721,9 +1708,8 @@ AC_ARG_WITH(,[Input plugins:])
 
 dnl  live555 input
 dnl
-AC_ARG_ENABLE(live555,
-[  --enable-live555        live555 RTSP input plugin (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([live555])], [
+VLC_FEATURE_OPTION([live555], [live555 RTSP input plugin])
+AS_IF([VLC_FEATURE_ENABLED([live555])], [
   AC_ARG_WITH(live555-tree,
     [  --with-live555-tree=PATH live.com tree for static linking])
 
@@ -1848,9 +1834,8 @@ PKG_ENABLE_MODULES_VLC([DV], [access_dv], [libraw1394 >= 2.0.1 libavc1394 >= 0.5
 dnl
 dnl dvdread module: check for libdvdread
 dnl
-AC_ARG_ENABLE(dvdread,
-[  --enable-dvdread        dvdread input module (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([dvdread])], [
+VLC_FEATURE_OPTION([dvdread], [dvdread input module])
+AS_IF([VLC_FEATURE_ENABLED([dvdread])], [
   AC_ARG_WITH(dvdread,
   [  --with-dvdread=PATH     libdvdread headers and libraries])
   AC_ARG_WITH(dvdread-tree,
@@ -1920,9 +1905,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvdread])], [
 dnl
 dnl  libdvdnav plugin
 dnl
-AC_ARG_ENABLE(dvdnav,
-  [  --enable-dvdnav         dvdnav input module (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([dvdnav])], [
+VLC_FEATURE_OPTION([dvdnav], [dvdnav input module])
+AS_IF([VLC_FEATURE_ENABLED([dvdnav])], [
   dnl Same hack than dvdread
   if test "${SYS}" = "mingw32" || test "${SYS}" = "darwin" || test "${SYS}" = "beos" ; then
       VLC_ADD_LIBS([dvdnav],[-ldvdcss])
@@ -1945,44 +1929,37 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvdnav])], [
 ])
 
 dnl
-dnl  Windows DirectShow access module
+dnl  Windows DirectShow and DirectShow BDA access module
 dnl
-AC_ARG_ENABLE(dshow,
-  [  --enable-dshow          Win32 DirectShow support (default enabled on Win32)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([dshow])], [
-  if test "${SYS}" = "mingw32"
-  then
+AS_IF([test "${SYS}" = "mingw32"], [
+  VLC_FEATURE_DEFAULT_ENABLE([dshow bda])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([dshow bda])
+])
+VLC_FEATURE_OPTION([dshow], [Win32 DirectShow support], [enabled on Win32])
+VLC_FEATURE_OPTION([bda], [Win32 DirectShow BDA support], [enabled on Win32])
+
+AS_IF([VLC_FEATURE_ENABLED([dshow]) && test "${SYS}" = "mingw32"], [
     AC_LANG_PUSH(C++)
       AC_CHECK_HEADERS(dshow.h,
       [ VLC_ADD_PLUGIN([dshow])
         VLC_ADD_CXXFLAGS([dshow],[])
         VLC_ADD_LIBS([dshow],[-lole32 -loleaut32 -luuid]) ])
     AC_LANG_POP(C++)
-  fi
 ])
 
-dnl
-dnl  Windows DirectShow BDA access module
-dnl
-AC_ARG_ENABLE(bda,
-  AS_HELP_STRING([--enable-bda],[Win32 DirectShow BDA support (default
-		  enabled on Win32)]))
-AS_IF([VLC_FEATURE_NOT_DISABLED([bda])], [
-  if test "${SYS}" = "mingw32"
-  then
+AS_IF([VLC_FEATURE_ENABLED([bda]) && test "${SYS}" = "mingw32"], [
       AC_CHECK_HEADERS(dshow.h,
       [ VLC_ADD_PLUGIN([bda])
         VLC_ADD_CXXFLAGS([bda],[])
         VLC_ADD_LIBS([bda],[-lstrmiids -lole32 -loleaut32 -luuid]) ])
-  fi
 ])
 
 
 dnl
 dnl  OpenCV wrapper and example filters
 dnl
-AC_ARG_ENABLE(opencv,
-  [  --enable-opencv         OpenCV (computer vision) filter (default disabled)])
+VLC_FEATURE_OPTION([opencv], [OpenCV (computer vision) filter], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([opencv]) && test "${CXX}" != ""], [
   AC_ARG_WITH(opencv-tree,
   [  --with-opencv-tree=PATH opencv tree for linking])
@@ -2024,9 +2001,8 @@ AS_IF([VLC_FEATURE_ENABLED([opencv]) && test "${CXX}" != ""], [
 dnl
 dnl  libsmbclient plugin
 dnl
-AC_ARG_ENABLE(smb,
-  [  --enable-smb            smb input module (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([smb])], [
+VLC_FEATURE_OPTION([smb], [smb input module])
+AS_IF([VLC_FEATURE_ENABLED([smb])], [
   AC_CHECK_HEADERS(libsmbclient.h,
     [ VLC_ADD_PLUGIN([access_smb])
       VLC_ADD_LIBS([access_smb],[-lsmbclient]) ],
@@ -2039,8 +2015,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([smb])], [
 dnl
 dnl sftp access support
 dnl
-AC_ARG_ENABLE(sftp,
-  [  --enable-sftp           sftp input access module (default disable)])
+VLC_FEATURE_OPTION([sftp], [sftp input access module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([sftp])], [
   AC_CHECK_HEADERS(libssh2.h, [
     VLC_ADD_PLUGIN([access_sftp])
@@ -2051,10 +2026,9 @@ AS_IF([VLC_FEATURE_ENABLED([sftp])], [
 dnl
 dnl  libdvbpsi ts demux/mux
 dnl
-AC_ARG_ENABLE(dvbpsi,
-  [  --enable-dvbpsi         dvbpsi ts mux and demux module (default enabled)])
+VLC_FEATURE_OPTION([dvbpsi], [dvbpsi ts mux and demux module])
 have_dvbpsi=no
-AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
+AS_IF([VLC_FEATURE_ENABLED([dvbpsi])], [
   AC_ARG_WITH(dvbpsi,
   [  --with-dvbpsi=PATH      libdvbpsi headers and libraries])
   AC_ARG_WITH(dvbpsi,
@@ -2065,7 +2039,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
     then
       AC_CHECK_HEADERS(dvbpsi/dr.h,
         [ VLC_ADD_PLUGIN([ts])
-          AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+          AS_IF([VLC_FEATURE_ENABLED([sout])], [
             VLC_ADD_PLUGIN([mux_ts])
           ])
           VLC_ADD_LIBS([mux_ts ts dvb],[-ldvbpsi])
@@ -2094,7 +2068,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
         dnl  Use a custom libdvbpsi
         AC_MSG_RESULT(${real_dvbpsi_tree}/src/.libs/libdvbpsi.a)
         VLC_ADD_PLUGIN([ts])
-        AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+        AS_IF([VLC_FEATURE_ENABLED([sout])], [
           VLC_ADD_PLUGIN([mux_ts])
         ])
         VLC_ADD_CPPFLAGS([mux_ts ts dvb],[-I${real_dvbpsi_tree}/src])
@@ -2123,7 +2097,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
     CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_test}"
     AC_CHECK_HEADERS([dvbpsi/dr.h],[
       VLC_ADD_PLUGIN([ts])
-      AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+      AS_IF([VLC_FEATURE_ENABLED([sout])], [
         AC_CHECK_LIB(dvbpsi, dvbpsi_SDTServiceAddDescriptor,
            [VLC_ADD_PLUGIN([mux_ts])], [], [${LDFLAGS_test} -ldvbpsi])
       ])
@@ -2131,7 +2105,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
       VLC_ADD_LIBS([mux_ts ts dvb],[${LDFLAGS_test} -ldvbpsi])
       have_dvbpsi=yes
     ],[
-      AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+      AS_IF([VLC_FEATURE_ENABLED([sout])], [
         AC_MSG_ERROR([Could not find libdvbpsi on your system: you may get it from www.videolan.org, you'll need at least version 0.1.6])
       ])
     ],
@@ -2156,8 +2130,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvbpsi])], [
 dnl
 dnl  Video4Linux plugin
 dnl
-AC_ARG_ENABLE(v4l,
-  [  --enable-v4l            Video4Linux input support (default disabled)])
+VLC_FEATURE_OPTION([v4l], [Video4Linux input support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([v4l])], [
   AC_ARG_WITH(v4l,
     [  --with-v4l=PATH         path to a v4l-enabled kernel tree],[],[])
@@ -2176,9 +2149,8 @@ AS_IF([VLC_FEATURE_ENABLED([v4l])], [
 dnl
 dnl libv4l1 support for video4linux.
 dnl
-AC_ARG_ENABLE( libv4l,
-  [  --enable-libv4l         Libv4l Video4Linux support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([libv4l]) && VLC_FEATURE_NOT_DISABLED([v4l])], [
+VLC_FEATURE_OPTION([libv4l], [Libv4l Video4Linux support])
+AS_IF([VLC_FEATURE_ENABLED([libv4l]) && VLC_FEATURE_ENABLED([v4l])], [
     PKG_CHECK_MODULES( LIBV4L, libv4l1, [
       VLC_ADD_LDFLAGS([v4l],[${LIBV4L_LIBS}])
       VLC_ADD_CFLAGS([v4l],[${LIBV4L_CFLAGS}])
@@ -2190,9 +2162,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libv4l]) && VLC_FEATURE_NOT_DISABLED([v4l])], [
 dnl
 dnl  Video4Linux2 plugin
 dnl
-AC_ARG_ENABLE(v4l2,
-  [  --enable-v4l2           Video4Linux2 input support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([v4l2])], [
+VLC_FEATURE_OPTION([v4l2], [Video4Linux2 input support])
+AS_IF([VLC_FEATURE_ENABLED([v4l2])], [
   AC_ARG_WITH(v4l2,
     [  --with-v4l2=PATH        path to a v4l2-enabled kernel tree],[],[])
   if test "${with_v4l2}" != "no" -a -n "${with_v4l2}"
@@ -2210,9 +2181,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([v4l2])], [
 dnl
 dnl libv4l2 support for video4linux.
 dnl
-AC_ARG_ENABLE( libv4l2,
-  [  --enable-libv4l2        Libv4l2 Video4Linux2 support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([libv4l2]) && VLC_FEATURE_NOT_DISABLED([v4l2])], [
+VLC_FEATURE_OPTION([libv4l2], [Libv4l2 Video4Linux2 support])
+AS_IF([VLC_FEATURE_ENABLED([libv4l2]) && VLC_FEATURE_ENABLED([v4l2])], [
     PKG_CHECK_MODULES( LIBV4L2, libv4l2, [
       VLC_ADD_LDFLAGS([v4l2],[${LIBV4L2_LIBS}])
       VLC_ADD_CFLAGS([v4l2],[${LIBV4L2_CFLAGS}])
@@ -2224,8 +2194,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libv4l2]) && VLC_FEATURE_NOT_DISABLED([v4l2])],
 dnl
 dnl  special access module for Hauppauge PVR cards
 dnl
-AC_ARG_ENABLE(pvr,
-  [  --enable-pvr            PVR cards access module (default disabled)])
+VLC_FEATURE_OPTION([pvr], [PVR cards access module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([pvr])], [
   VLC_ADD_PLUGIN([pvr])
   AC_ARG_WITH(videodev2,
@@ -2261,8 +2230,7 @@ PKG_ENABLE_MODULES_VLC([GNOMEVFS], [access_gnomevfs], [gnome-vfs-2.0], [GnomeVFS
 dnl
 dnl  VCDX modules
 dnl
-AC_ARG_ENABLE(vcdx,
-  [  --enable-vcdx           VCD with navigation via libvcdinfo (default disabled)])
+VLC_FEATURE_OPTION([vcdx], [VCD with navigation via libvcdinfo], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([vcdx])], [
 	PKG_CHECK_MODULES(LIBCDIO, [libcdio >= 0.78.2 libiso9660 >= 0.72],
 	  [VLC_ADD_LIBS([vcdx],[$LIBCDIO_LIBS])
@@ -2278,13 +2246,9 @@ AS_IF([VLC_FEATURE_ENABLED([vcdx])], [
 dnl
 dnl  Built-in CD-DA and VCD module
 dnl
-AC_ARG_ENABLE(vcd,
-  [  --enable-vcd            built-in VCD and CD-DA (default enabled)])
-
-AC_ARG_ENABLE(libcddb,
-  [  --enable-libcddb        CDDB support for libcdio audio CD (default enabled)])
-
-AS_IF([VLC_FEATURE_NOT_DISABLED([vcd])], [
+VLC_FEATURE_OPTION([vcd], [built-in VCD and CD-DA])
+VLC_FEATURE_OPTION([libcddb], [CDDB support for libcdio audio CD])
+AS_IF([VLC_FEATURE_ENABLED([vcd])], [
   AC_MSG_CHECKING(for cdrom_msf0 in linux/cdrom.h)
   AC_EGREP_HEADER(cdrom_msf0,linux/cdrom.h,[
     AC_MSG_RESULT(yes)
@@ -2323,7 +2287,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([vcd])], [
     VLC_ADD_LIBS([vcdx cdda],[-liconv])
   fi
 
-  AS_IF([VLC_FEATURE_NOT_DISABLED([libcddb])], [
+  AS_IF([VLC_FEATURE_ENABLED([libcddb])], [
     PKG_CHECK_MODULES(LIBCDDB, libcddb >= 0.9.5, [
       HAVE_LIBCDDB=yes
       AC_DEFINE(HAVE_LIBCDDB, 1, [Define this if you have libcddb installed])
@@ -2338,9 +2302,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([vcd])], [
 dnl
 dnl  DVB-S/DVB-T/DVB-C satellite/teresterial/cable input using v4l2
 dnl
-AC_ARG_ENABLE(dvb,
-  [  --enable-dvb            DVB-S/T/C card support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([dvb])], [
+VLC_FEATURE_OPTION([dvb], [DVB-S/T/C card support])
+AS_IF([VLC_FEATURE_ENABLED([dvb])], [
     AS_IF([test "${have_dvbpsi}" = "yes" ],[
     AC_ARG_WITH(dvb,
      [  --with-dvb=PATH         path to a dvb- and v4l2-enabled kernel tree],[],[])
@@ -2361,9 +2324,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dvb])], [
 dnl
 dnl  Screen capture module
 dnl
-AC_ARG_ENABLE(screen,
-  [  --enable-screen         Screen capture support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([screen])], [
+VLC_FEATURE_OPTION([screen], [Screen capture support])
+AS_IF([VLC_FEATURE_ENABLED([screen])], [
   if test "${SYS}" = "darwin"; then
     AC_CHECK_HEADERS(OpenGL/gl.h, [
       AC_CHECK_HEADERS(ApplicationServices/ApplicationServices.h, [
@@ -2403,11 +2365,11 @@ dnl
 dnl  ogg demux plugin
 dnl
 PKG_ENABLE_MODULES_VLC([OGG], [], [ogg >= 1.0], [Ogg demux support], [auto])
-AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+AS_IF([VLC_FEATURE_ENABLED([sout])], [
     PKG_ENABLE_MODULES_VLC([MUX_OGG], [], [ogg >= 1.0], [Ogg demux support], [auto])
 ])
 
-AS_IF([VLC_FEATURE_NOT_DISABLED([sout])], [
+AS_IF([VLC_FEATURE_ENABLED([sout])], [
 dnl Check for libshout
 PKG_ENABLE_MODULES_VLC([SHOUT], [access_output_shout], [shout >= 2.1], [libshout output plugin], [auto])
 ])
@@ -2415,9 +2377,8 @@ PKG_ENABLE_MODULES_VLC([SHOUT], [access_output_shout], [shout >= 2.1], [libshout
 dnl
 dnl  matroska demux plugin
 dnl
-AC_ARG_ENABLE(mkv,
-  [  --enable-mkv            Matroska demux support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([mkv]) && test "${CXX}" != ""], [
+VLC_FEATURE_OPTION([mkv], [Matroska demux support])
+AS_IF([VLC_FEATURE_ENABLED([mkv]) && test "${CXX}" != ""], [
   AC_LANG_PUSH(C++)
   AC_CHECK_HEADERS(ebml/EbmlVersion.h, [
     AC_MSG_CHECKING(for libebml version >= 0.7.7)
@@ -2469,9 +2430,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([mkv]) && test "${CXX}" != ""], [
 dnl
 dnl  modplug demux plugin
 dnl
-AC_ARG_ENABLE(mod,
-  [  --enable-mod            Mod demux support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([mod])], [
+VLC_FEATURE_OPTION([mod], [Mod demux support])
+AS_IF([VLC_FEATURE_ENABLED([mod])], [
   AC_ARG_WITH(mod-tree,
   [  --with-mod-tree=PATH    mod tree for static linking])
   if test -n "${with_mod_tree}"
@@ -2508,9 +2468,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([mod])], [
 dnl
 dnl  mpc demux plugin
 dnl
-AC_ARG_ENABLE(mpc,
-  [  --enable-mpc            Mpc demux support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([mpc])], [
+VLC_FEATURE_OPTION([mpc], [Mpc demux support])
+AS_IF([VLC_FEATURE_ENABLED([mpc])], [
   AC_CHECK_HEADERS([mpc/mpcdec.h], [
     VLC_ADD_PLUGIN([mpc])
     VLC_ADD_LIBS([mpc],[-lmpcdec])],
@@ -2522,9 +2481,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([mpc])], [
 dnl
 dnl  game music emu demux plugin
 dnl
-AC_ARG_ENABLE(gme,
-  [  --enable-gme            Game Music Emu demux support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([gme]) && test "${CXX}" != ""], [
+VLC_FEATURE_OPTION([gme], [Game Music Emu demux support])
+AS_IF([VLC_FEATURE_ENABLED([gme]) && test "${CXX}" != ""], [
   AC_LANG_PUSH(C++)
   AC_ARG_WITH(gme-tree,
   [  --with-gme-tree=PATH    gme tree for static linking])
@@ -2565,8 +2523,7 @@ AC_ARG_WITH(,[Codec plugins:])
 dnl
 dnl wmafixed plugin
 dnl
-AC_ARG_ENABLE(wma-fixed,
-  [  --enable-wma-fixed      libwma-fixed module (default disabled)])
+VLC_FEATURE_OPTION([wma-fixed], [libwma-fixed module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([wma-fixed])], [
   VLC_ADD_PLUGIN([wma_fixed])
 ])
@@ -2574,8 +2531,7 @@ AS_IF([VLC_FEATURE_ENABLED([wma-fixed])], [
 dnl
 dnl shine fixed point mp3 encoder
 dnl
-AC_ARG_ENABLE(shine,
-  [  --enable-shine          shine mp3 encoding module (default disabled)])
+VLC_FEATURE_OPTION([shine], [shine mp3 encoding module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([shine])], [
   VLC_ADD_PLUGIN([shine])
 ])
@@ -2583,9 +2539,8 @@ AS_IF([VLC_FEATURE_ENABLED([shine])], [
 dnl
 dnl  mad plugin
 dnl
-AC_ARG_ENABLE(mad,
-  [  --enable-mad            libmad module (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([mad])], [
+VLC_FEATURE_OPTION([mad], [libmad module])
+AS_IF([VLC_FEATURE_ENABLED([mad])], [
   AC_ARG_WITH(mad,
     [  --with-mad=PATH         path to libmad],[],[])
   if test "${with_mad}" != "no" -a -n "${with_mad}"
@@ -2640,8 +2595,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([mad])], [
 dnl
 dnl   libid3tag support (FIXME!!! doesn't work with new input)
 dnl
-AC_ARG_ENABLE( id3tag,
-[  --disable-id3tag        id3tag metadata reader plugin (default disabled)])
+VLC_FEATURE_OPTION([id3tag], [id3tag metadata reader plugin], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([id3tag])], [
   AC_CHECK_HEADERS(id3tag.h, [
       AS_IF([test "${have_zlib}" = "yes"],[
@@ -2651,16 +2605,14 @@ AS_IF([VLC_FEATURE_ENABLED([id3tag])], [
     ])
 ])
 
-AC_ARG_ENABLE(merge-ffmpeg,
-[  --enable-merge-ffmpeg   merge FFmpeg-based plugins (default disabled)])
+VLC_FEATURE_OPTION([merge-ffmpeg], [merge FFmpeg-based plugins], [disabled])
 AM_CONDITIONAL([MERGE_FFMPEG], [AS_IF([VLC_FEATURE_ENABLED([ffmpeg])])])
 
 dnl
 dnl  avcodec decoder/encoder plugin
 dnl
-AC_ARG_ENABLE(avcodec,
-[  --enable-avcodec        libavcodec codec (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([avcodec])], [
+VLC_FEATURE_OPTION([avcodec], [libavcodec codec])
+AS_IF([VLC_FEATURE_ENABLED([avcodec])], [
   PKG_CHECK_MODULES(AVCODEC,[libavcodec >= 51.48.0 libavutil],
     [
       VLC_SAVE_FLAGS
@@ -2681,10 +2633,9 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([avcodec])], [
 dnl
 dnl libva needs avcodec
 dnl
-AC_ARG_ENABLE(libva,
-  [  --enable-libva          libva VAAPI support (default auto)])
-
-AS_IF([VLC_FEATURE_NOT_DISABLED([libva])], [
+VLC_FEATURE_DEFAULT_ENABLE([libva])
+VLC_FEATURE_OPTION([libva], [libva VAAPI support])
+AS_IF([VLC_FEATURE_ENABLED([libva])], [
   AS_IF([VLC_FEATURE_ENABLED([avcodec])], [
     PKG_CHECK_MODULES(LIBVA, [libva libva-x11],
       [
@@ -2717,10 +2668,9 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libva])], [
 dnl
 dnl dxva2 needs avcodec
 dnl
-AC_ARG_ENABLE(dxva2,
-  [  --enable-dxva2          DxVA2  support (default auto)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([dxva2])], [
-  if test "${SYS}" = "mingw32"; then
+VLC_FEATURE_DEFAULT_ENABLE([dxva2])
+VLC_FEATURE_OPTION([dxva2], [DxVA2 support], [auto])
+AS_IF([VLC_FEATURE_ENABLED([dxva2]) && test "${SYS}" = "mingw32"], [
   AS_IF([test "x${have_avcodec}" = "xyes"], [
     AC_CHECK_HEADERS(dxva2api.h, 
       [
